constexpr int XG = 40;
constexpr int YG = 40;
constexpr int ZG = 10;

#pragma imcl grid(input)
#pragma imcl boundary_cond(input:none)
void stencil_kernel(
        int var,
        int num_iter,
        int num_vars,
        Image<double> input
) {
    constexpr int X = XG + 2;
    constexpr int Y = YG + 2;
    constexpr int Z = ZG + 2;

    for (int i = 0; i < num_iter; ++i) {
        const int READ = (i * (num_vars + 1) + (var + 1)) * X * Y * Z;
        const int WRITE = (i * (num_vars + 1) + var) * X * Y * Z;
        Block<double> read = input + READ;
        Block<double> write = input + WRITE;
        for (int z = 1; z <= ZG; ++z) {
            write[z][idy + 1][idx + 1] =
                     ( read[z - 1][idy + 1][idx + 1]
                     + read[z][idy][idx + 1]
                     + read[z][idy + 1][idx]
                     + read[z][idy + 1][idx + 1]
                     + read[z][idy + 1][idx + 2]
                     + read[z][idy + 2][idx + 1]
                     + read[z + 1][idy + 1][idx + 1]) / 7.0;
        }
    }
}
