//! miniAMR v3 uses 3d memory instead of 5d.
//!
//! This version can hopefully be used together with all memory optimizations.

#pragma imcl grid(input)
#pragma imcl boundary_cond(input:none,output:none)
void stencil_kernel(Block<double> input, Block<double> output) {
    output[idz + 1][idy + 1][idx + 1] =
            (input[idz][idy + 1][idx + 1]
             + input[idz + 1][idy][idx + 1]
             + input[idz + 1][idy + 1][idx]
             + input[idz + 1][idy + 1][idx + 1]
             + input[idz + 1][idy + 1][idx + 2]
             + input[idz + 1][idy + 2][idx + 1]
             + input[idz + 2][idy + 1][idx + 1]) / 7.0;
}
