// Copyright (c) 2016, Thomas L. Falch
// For conditions of distribution and use, see the accompanying LICENSE and README files

// This file is part of the ImageCL source-to-source compiler
// developed at the Norwegian University of Science and technology

#include "rose.h"
#include "constantmemtransformer.h"
#include "astutil.h"

using namespace SageBuilder;
using namespace SageInterface;
using namespace std;

ConstantMemTransformer::ConstantMemTransformer(SgProject *project, KernelInfo kernelInfo, Parameters params) : project(
        project), kernelInfo(kernelInfo), params(params) {
}

void ConstantMemTransformer::transform(const Settings &settings) {
    SgFunctionDeclaration *funcDef = AstUtil::getFunctionDeclaration(project, kernelInfo.getKernelName());

    if (settings.language == Language::OpenCL) {
        const Rose_STL_Container<SgInitializedName *> &args = funcDef->get_args();

        for (SgInitializedName *arg : args) {

            if (params.constantMemArrays->count(arg->get_name().str())) {
                if (settings.language == Language::OpenCL) {
                    SgModifierType *modifierType = buildModifierType(arg->get_typeptr());
                    modifierType->get_typeModifier().setOpenclConstant();
                    arg->set_typeptr(modifierType);
                }
            }
        }
    } else {

    }
}
