#!/usr/bin/env bash
set -o errexit
set -o nounset
set -o pipefail
set -o xtrace

x=$1
y=$2
z=$3

sed -i -e "s/XG = [0-9]*;/XG = $x;/" -e "s/YG = [0-9]*;/YG = $y;/" -e "s/ZG = [0-9]*;/ZG = $z;/" ref/kernel.cu
sed -i -e "s/#define DUMP [0-1]/#define DUMP 0/" ref/proto.h

cd ./cmake-build-release/
cmake .. -DCMAKE_BUILD_TYPE=Release -DCUDA_NVCC_FLAGS=-D_FORCE_INLINES -G "CodeBlocks - Unix Makefiles"
make miniAMR_c
make miniAMR_v0_cuda
make miniAMR_v1_cuda
make miniAMR_v2_cuda
make miniAMR_v3_cuda
make miniAMR_v4_cuda
if (( (x + 2) * (y + 2) * (z + 2) * 8 < 65536 )) ; then
make miniAMR_v5_cuda
fi
make miniAMR_v6_cuda

mkdir -p ../files/${x}x${y}x${z}

./miniAMR_c       --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/c.txt
./miniAMR_v0_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v0.txt
./miniAMR_v1_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v1.txt
./miniAMR_v2_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v2.txt
./miniAMR_v3_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v3.txt
./miniAMR_v4_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v4.txt
if (( (x + 2) * (y + 2) * (z + 2) * 8 < 65536 )) ; then
./miniAMR_v5_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v5.txt
fi
./miniAMR_v6_cuda --nx ${x} --ny ${y} --nz ${z} > ../files/${x}x${y}x${z}/v6.txt
